package applications.basics;

/** Export Query exports a query to a file and is a part of Admin...
 *  Version 1.0 15. Aug. 1999
 *  Fredy Fischer 
 *
 *  this has been created to export SQL-Resultsets
 */


/** Admin is a Tool around SQL to do basic jobs
    for DB-Administrations, like:
    - create/ drop tables
    - create  indices
    - perform sql-statements
    - simple form
    - a guided query
    and a other usefull things in DB-arena

    Admin V1.1
    Copyright (c) 1999 Fredy Fischer
                       se-afs@dial.eunet.ch

		       Fredy Fischer
		       Hulmenweg 36
		       8405 Winterthur
		       Switzerland

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

**/


import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.sql.*;
import javax.swing.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JPanel; 
import javax.swing.JFrame;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;

public class ExportQuery extends JPanel { 

   private File file = null;
   private ResultSet sqlresult;
   private JTextArea info1,info2;
   private JButton cancel;

    
    String fieldSeparator;
    
    /**
       * Get the value of fieldSeparator.
       * @return Value of fieldSeparator.
       */
    public String getFieldSeparator() {return fieldSeparator;}
    
    /**
       * Set the value of fieldSeparator.
       * @param v  Value to assign to fieldSeparator.
       */
    public void setFieldSeparator(String  v) {this.fieldSeparator = v;}
    

   String host;
    
    /**
       * Get the value of host.
       * @return Value of host.
       */
    public String getHost() {return host;}
    
    /**
       * Set the value of host.
       * @param v  Value to assign to host.
       */
    public void setHost(String  v) {this.host = v;}
    

    String user;
    
    /**
       * Get the value of user.
       * @return Value of user.
       */
    public String getUser() {return user;}
    
    /**
       * Set the value of user.
       * @param v  Value to assign to user.
       */
    public void setUser(String  v) {this.user = v;}
    

    String password;
    
    /**
       * Get the value of password.
       * @return Value of password.
       */
    public String getPassword() {return password;}
    
    /**
       * Set the value of password.
       * @param v  Value to assign to password.
       */
    public void setPassword(String  v) {this.password = v;}
    

    String database;
    
    /**
       * Get the value of database.
       * @return Value of database.
       */
    public String getDatabase() {return database;}
    
    /**
       * Set the value of database.
       * @param v  Value to assign to database.
       */
    public void setDatabase(String  v) {this.database = v;}
    

    public ExportQuery (String host,String user, String password, String database) {

	setHost(host);
	setUser(user);
	setPassword(password);
	setDatabase(database);
	setQuery(null);
	setFieldSeparator(";");

	this.setLayout(new BorderLayout());

	info1 = new JTextArea(5,40);
	JScrollPane scrollpane = new JScrollPane(info1);
	this.add("West",scrollpane);

	info2 = new JTextArea(5,20);
	JScrollPane scrollpane2 = new JScrollPane(info2);
	this.add("East",scrollpane2);

	JPanel bp = new JPanel();
	bp.setLayout(new FlowLayout());

	cancel = new JButton("Cancel");
	bp.add(cancel);
	this.add("South",bp);


    }


    
    String query;
    
    /**
       * Get the value of query.
       * @return Value of query.
       */
    public String getQuery() {return query;}
    
    /**
       * Set the value of query.
       * @param v  Value to assign to query.
       */
    public void setQuery(String  v) {this.query = v;}
    
    public void selectFile() {


	JFileChooser chooser = new JFileChooser();
	chooser.setDialogType(JFileChooser.SAVE_DIALOG);
	chooser.setDialogTitle("Select Exportfile");
	
	int returnVal = chooser.showSaveDialog(this);
	if(returnVal == JFileChooser.APPROVE_OPTION) {
	    file = chooser.getSelectedFile();
	    verify();
	} else { file = null; }

    }

    public void verify() {

	if (file.exists() ) {

             String string1 = "Overwrite";
             String string2 = "Cancel";
             Object[] options = {string1, string2};
             int n = JOptionPane.showOptionDialog(null,
                              "This file already exists!",
                              "File exists",
                              JOptionPane.YES_NO_OPTION,
                              JOptionPane.QUESTION_MESSAGE,
                              null,     //don't use a custom Icon
                              options,  //the titles of buttons
                              string2); //the title of the default button
               if (n == JOptionPane.NO_OPTION)   file = null;

	}
    }


    public void export() {

	if ( (getQuery() != null )  && ( file != null ) ) {

	         t_connect con = new t_connect(getHost(), getUser(), getPassword(),getDatabase());  
		 if (con.getError() != null) message("Connection Error: "+ con.getError());
		 try {
		     sqlresult = con.stmt.executeQuery(getQuery());
		 } catch (Exception e) {  message("Query-Error: " +e.getMessage().toString()); }

		 String fileContent = "";
		 try {
		     ResultSetMetaData metaData = sqlresult.getMetaData();
		     int columnCount = metaData.getColumnCount();

		     // create Header
		     for (int i = 0; i < columnCount; i++) {
			 if (i >0) fileContent = fileContent + getFieldSeparator();
			 fileContent = fileContent + "\"" + metaData.getColumnName(i+1) + "\"";
		     }
		     fileContent = fileContent + System.getProperty("line.separator");


		     while ( sqlresult.next() ) {
			 for (int i = 0; i < columnCount; i++) {
				if (i >0) fileContent = fileContent + getFieldSeparator();
				switch (metaData.getColumnType(i+1) ) {
				case java.sql.Types.INTEGER:
				    fileContent = fileContent + Integer.toString(sqlresult.getInt(i+1));
				    break;
				case java.sql.Types.FLOAT:
				    fileContent = fileContent + Float.toString(sqlresult.getFloat(i+1));
				    break;
				case java.sql.Types.DOUBLE:
				    fileContent = fileContent + Double.toString(sqlresult.getDouble(i+1));
				    break;
				case java.sql.Types.DATE:
				    fileContent = fileContent + "\"" + sqlresult.getDate(i+1).toString() + "\"";
				    break;
				default:
				    fileContent = fileContent + "\"" + sqlresult.getString(i+1) + "\"";
				    break;
				}
			 }
			 fileContent = fileContent + System.getProperty("line.separator");
			 con.close();
		     }
		 } catch (Exception e) { message("Exception while exporting: " + e.getMessage().toString());
		 }
		save(fileContent);
	}
    }

    private void save(String s) {
	info1.setText(s);
        this.updateUI();
	try {
	      	DataOutputStream outptstr = new DataOutputStream(
		     new BufferedOutputStream(
		     new FileOutputStream(file)));
			 outptstr.writeBytes(s);
			 outptstr.flush();
			 outptstr.close();
			 message("successfully exported...");
	} catch(IOException execp) { message(execp.toString()); }
    }



    public void message(String msg) {

	info2.append(msg + "\n");
        this.updateUI();

    }

    public static void main(String args[] ) {
	if (args.length != 5 ) {
	    System.out.println("Syntax: java mysqladmin.ExportQuery host user password database query");
	    System.exit(0);
	}
	JFrame frame = new JFrame("Export");
	frame.addWindowListener(new WindowAdapter() {
	    public void windowActivated(WindowEvent e) {}
	    public void windowClosed(WindowEvent e) {}
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	    public void windowDeactivated(WindowEvent e) {}
	    public void windowDeiconified(WindowEvent e) {}
	    public void windowIconified(WindowEvent e) {}
	    public void windowOpened(WindowEvent e) {}});
	ExportQuery eq = new ExportQuery(args[0], args[1], args[2], args[3]);
	frame.getContentPane().add(eq);
        frame.pack();
	frame.setVisible(true);
	eq.setQuery(args[4]);
	eq.selectFile();
	eq.export();
	eq.cancel.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.exit(0);
		}});
	
    }
}
	    
