package applications.basics;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;
import java.awt.event.*;

public class ImageButton extends JButton {


    public ImageButton() {

    }

public ImageButton(String text, String image, String toolTip) {
	if ( image != null ) {
                ImageIcon img = getImageIcon(image);
		this.setIcon(grayed(img.getImage()));
		this.setRolloverIcon(img);
		this.setRolloverEnabled(true);
	}
	if (text != null ) this.setText(text);
	if (toolTip != null ) this.setToolTipText(toolTip);
}


    public String getInfo() {


	return "This is a ImageButton\n" +
               "done for Fredy's Java-things\n" +
	       "parameters are: text-on-button,image,toolTip-Text\n" +
	       "it loads Images either from the device.images\n" +
	       "where it resides or from the property given over by \n" +
	       "-D image=<path-to-images>";


    }

    public ImageIcon getImageIcon(String image) {

	ImageIcon img = null;

	if ( image != null ) {
		String releaseImage = System.getProperty("image");

		try {
		if (releaseImage == null) {
			img = new ImageIcon(ImageButton.class.getResource("images"+ File.separator + image));
		} else {
			img = new ImageIcon(releaseImage + File.separator + image);
		}
		}  catch (Exception excp) { ;}
	}
	return img;

    }

    public ImageIcon grayed(Image orig) {
	ImageFilter filter = new GrayFilter();
	ImageProducer producer = new FilteredImageSource(orig.getSource(), filter);
	ImageIcon imgIcon = new ImageIcon( createImage(producer) ) ;
	return imgIcon;
    }
    

    public static void main(String args[]) {

	System.out.println("Fredy's ImageButton\n" +
			   "is based on JButton and does a Rollover-Image\n" +
			   "use it as follows: java -D image=<path-to-images> applications.basics.ImageButton <text> <image> <tooltip>\n");
	if (args.length != 3 ) System.exit(0);
	JFrame frame = new JFrame("TEST");
	ImageButton imgB = new ImageButton(args[0],args[1],args[2]);
	frame.getContentPane().add(imgB);
	frame.pack();
	frame.setVisible(true);
	frame.addWindowListener(new WindowAdapter() {
	    public void windowActivated(WindowEvent e) {}
	    public void windowClosed(WindowEvent e) {}
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	    public void windowDeactivated(WindowEvent e) {}
	    public void windowDeiconified(WindowEvent e) {}
	    public void windowIconified(WindowEvent e) {}
	    public void windowOpened(WindowEvent e) {}});
	
    }


}

class GrayFilter extends RGBImageFilter {
    public GrayFilter() { canFilterIndexColorModel = true; }
    public int filterRGB(int x, int y, int rgb) {
	int a = rgb & 0xff000000;
	int r = (((rgb & 0xff0000) + 0x1800000)/3) & 0xff0000;
	int g = (((rgb & 0x00ff00) + 0x018000)/3) & 0x00ff00;
	int b = (((rgb & 0x0000ff) + 0x000180)/3) & 0x0000ff;
	return a | r | g | b;
    }
}
